﻿Imports System.Data.OleDB
Imports System.Security.Cryptography
Imports System.Text

Public Class frmSales
    Dim rdr As OleDbDataReader = Nothing
    Dim dtable As DataTable
    Dim con As OleDbConnection = Nothing
    Dim adp As OleDbDataAdapter
    Dim ds As DataSet
    Dim cmd As OleDbCommand = Nothing
    Dim dt As New DataTable
    Dim sSql As String


    Private Sub auto()
        txtInvoiceNo.Text = "INV-" & GetUniqueKey(8)

    End Sub

    Sub Reset()
        txtInvoiceNo.Text = ""
        txtSupplierID.Text = ""
        txtSupplierName.Text = ""
        dtpTransactionDate.Text = Today
        txtProductCode.Text = ""
        txtProductName.Text = ""
        txtWeight.Text = ""
        txtPrice.Text = ""
        txtAvailablePackets.Text = ""
        txtPackets.Text = ""
        txtTotalAmount.Text = ""
        txtSubTotal.Text = ""
        txtTaxPer.Text = ""
        txtTaxAmt.Text = ""
        txtPaidToSupplier.Text = ""
        txtProfit.Text = ""
        btnPrint.Enabled = False
        Save.Enabled = True
        Delete.Enabled = False
        btnUpdate.Enabled = False
        ListView1.Enabled = True
        ListView1.Items.Clear()
        Button7.Enabled = True
        btnRemove.Enabled = False
    End Sub
    Private Sub NewRecord_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewRecord.Click
        Reset()
        Reset()
    End Sub

    Private Sub Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Save.Click

        If Len(Trim(txtSupplierID.Text)) = 0 Then
            MessageBox.Show("Select Supplier id", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtSupplierID.Focus()
            Exit Sub
        End If
        If Len(Trim(txtSupplierName.Text)) = 0 Then
            MessageBox.Show("Select Supplier name", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Button1.Focus()
            Exit Sub
        End If

        If Len(Trim(txtTaxPer.Text)) = 0 Then
            MessageBox.Show("Please enter tax percentage", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtTaxPer.Focus()
            Exit Sub
        End If
        If Len(Trim(txtTaxAmt.Text)) = 0 Then
            MessageBox.Show("Please enter tax amount", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtTaxAmt.Focus()
            Exit Sub
        End If
        If Len(Trim(txtPaidToSupplier.Text)) = 0 Then
            MessageBox.Show("Please enter paid to supplier", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtPaidToSupplier.Focus()
            Exit Sub
        End If
        If ListView1.Items.Count = 0 Then
            MessageBox.Show("sorry no product added", "", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Exit Sub
        End If
        Try
            For j = 0 To ListView1.Items.Count - 1
                Dim con As New OleDbConnection(cs)
                con.Open()
                Dim cmd As New OleDbCommand("SELECT Packets from Temp_stock where ProductCode= '" & ListView1.Items(j).SubItems(1).Text & "' and Packets =" & ListView1.Items(j).SubItems(5).Text & "", con)
                Dim da As New OleDbDataAdapter(cmd)
                Dim ds As DataSet = New DataSet()
                da.Fill(ds)
                If ds.Tables(0).Rows.Count > 0 Then
                    lblPackets.Text = ds.Tables(0).Rows(0)("Packets")
                    If Val(ListView1.Items(j).SubItems(5).Text) > Val(lblPackets.Text) Then
                        MessageBox.Show("added Packets to cart are more than" & vbCrLf & "available Packets of product code '" & ListView1.Items(j).SubItems(1).Text & "' and Packets = " & ListView1.Items(j).SubItems(5).Text & "", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        txtTaxAmt.Text = ""
                        txtTaxPer.Text = ""
                        txtPaidToSupplier.Text = ""
                        txtProfit.Text = ""
                        Exit Sub
                    End If
                End If
                con.Close()
            Next
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
        Try
            auto()
            con = New OleDbConnection(cs)
            con.Open()
            Dim ct As String = "select invoiceno from billinfo where invoiceno=@find"

            cmd = New OleDbCommand(ct)
            cmd.Connection = con
            cmd.Parameters.Add(New OleDbParameter("@find", System.Data.OleDb.OleDbType.VarChar, 20, "invoiceno"))
            cmd.Parameters("@find").Value = txtInvoiceNo.Text
            rdr = cmd.ExecuteReader()

            If rdr.Read Then
                MessageBox.Show("Invoice No. Already Exists", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

                If Not rdr Is Nothing Then
                    rdr.Close()
                End If

            Else



                con = New OleDbConnection(cs)
                con.Open()

                Dim cb As String = "insert Into billinfo(InvoiceNo,BillingDate,SupplierID,SubTotal,TaxPercentage,TaxAmount,PaidToSupplier,Profit) VALUES ('" & txtInvoiceNo.Text & "',#" & dtpTransactionDate.Text & "#,'" & txtSupplierID.Text & "','" & CInt(txtSubTotal.Text) & "','" & CDbl(txtTaxPer.Text) & "','" & CInt(txtTaxAmt.Text) & "','" & CDbl(txtPaidToSupplier.Text) & "','" & CDbl(txtProfit.Text) & "')"

                cmd = New OleDbCommand(cb)

                cmd.Connection = con


                cmd.ExecuteReader()

                If con.State = ConnectionState.Open Then
                    con.Close()
                End If

                con.Close()

                For i = 0 To ListView1.Items.Count - 1

                    con = New OleDbConnection(cs)

                    Dim cd As String = "insert Into ProductSold(InvoiceNo,ProductCode,ProductName,Weight,Price,Packets,TotalAmount) VALUES (@InvoiceNo,@ProductCode,@ProductName,@Weight,@Price,@Packets,@TotalAmount)"
                    cmd = New OleDbCommand(cd)
                    cmd.Connection = con
                    cmd.Parameters.AddWithValue("InvoiceNo", txtInvoiceNo.Text)
                    cmd.Parameters.AddWithValue("ProductCode", ListView1.Items(i).SubItems(1).Text)
                    cmd.Parameters.AddWithValue("ProductName", ListView1.Items(i).SubItems(2).Text)
                    cmd.Parameters.AddWithValue("Weight", ListView1.Items(i).SubItems(3).Text)
                    cmd.Parameters.AddWithValue("Price", ListView1.Items(i).SubItems(4).Text)
                    cmd.Parameters.AddWithValue("Packets", ListView1.Items(i).SubItems(5).Text)
                    cmd.Parameters.AddWithValue("TotalAmount", ListView1.Items(i).SubItems(6).Text)
                    con.Open()
                    cmd.ExecuteNonQuery()
                    con.Close()
                Next

                For i = 0 To ListView1.Items.Count - 1

                    con = New OleDbConnection(cs)
                    con.Open()

                    Dim cb1 As String = "update temp_stock set Packets = Packets - " & ListView1.Items(i).SubItems(5).Text & " where productcode= '" & ListView1.Items(i).SubItems(1).Text & "'"

                    cmd = New OleDbCommand(cb1)

                    cmd.Connection = con


                    cmd.ExecuteNonQuery()
                    con.Close()
                Next
                Save.Enabled = False
                btnPrint.Enabled = True
                MessageBox.Show("Successfully completed", "Order", MessageBoxButtons.OK, MessageBoxIcon.Information)

            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try



    End Sub


    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Try
            If Len(Trim(txtProductCode.Text)) = 0 Then
                MessageBox.Show("Please select product code", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Button1.Focus()
                Exit Sub
            End If
            If Len(Trim(txtPackets.Text)) = 0 Then
                MessageBox.Show("Please enter no. of packets", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                txtPackets.Focus()
                Exit Sub
            End If
            If Val(txtPackets.Text) = 0 Then
                MessageBox.Show("no. of packets can not be zero", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                txtPackets.Focus()
                Exit Sub
            End If
            Dim temp As Integer
            temp = ListView1.Items.Count()
            If temp = 0 Then
                Dim i As Integer
                Dim lst As New ListViewItem(i)
                lst.SubItems.Add(txtProductCode.Text)
                lst.SubItems.Add(txtProductName.Text)
                lst.SubItems.Add(txtWeight.Text)
                lst.SubItems.Add(txtPrice.Text)
                lst.SubItems.Add(txtPackets.Text)
                lst.SubItems.Add(txtTotalAmount.Text)
                ListView1.Items.Add(lst)
                i = i + 1
                txtSubTotal.Text = subtot()
                txtProductCode.Text = ""
                txtProductName.Text = ""
                txtWeight.Text = ""
                txtPrice.Text = ""
                txtAvailablePackets.Text = ""
                txtPackets.Text = ""
                txtTotalAmount.Text = ""
                Exit Sub
            End If

            For j = 0 To temp - 1
                If (ListView1.Items(j).SubItems(1).Text = txtProductCode.Text) Then
                    ListView1.Items(j).SubItems(1).Text = txtProductCode.Text
                    ListView1.Items(j).SubItems(2).Text = txtProductName.Text
                    ListView1.Items(j).SubItems(3).Text = txtWeight.Text
                    ListView1.Items(j).SubItems(4).Text = txtPrice.Text
                    ListView1.Items(j).SubItems(5).Text = Val(ListView1.Items(j).SubItems(5).Text) + Val(txtPackets.Text)
                    ListView1.Items(j).SubItems(6).Text = Val(ListView1.Items(j).SubItems(6).Text) + Val(txtTotalAmount.Text)
                    txtSubTotal.Text = subtot()
                    txtProductCode.Text = ""
                    txtProductName.Text = ""
                    txtWeight.Text = ""
                    txtPrice.Text = ""
                    txtAvailablePackets.Text = ""
                    txtPackets.Text = ""
                    txtTotalAmount.Text = ""
                    Exit Sub

                End If
            Next j
            Dim k As Integer
            Dim lst1 As New ListViewItem(k)

            lst1.SubItems.Add(txtProductCode.Text)
            lst1.SubItems.Add(txtProductName.Text)
            lst1.SubItems.Add(txtWeight.Text)
            lst1.SubItems.Add(txtPrice.Text)
            lst1.SubItems.Add(txtPackets.Text)
            lst1.SubItems.Add(txtTotalAmount.Text)
            ListView1.Items.Add(lst1)
            k = k + 1
            txtSubTotal.Text = subtot()
            txtProductCode.Text = ""
            txtProductName.Text = ""
            txtWeight.Text = ""
            txtPrice.Text = ""
            txtAvailablePackets.Text = ""
            txtPackets.Text = ""
            txtTotalAmount.Text = ""
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try


    End Sub
    Public Function subtot() As Double

        Dim i, j As Integer
        Dim k As Double
        i = 0
        j = 0
        k = 0

        Try
            j = ListView1.Items.Count
            For i = 0 To j - 1
                k = k + CDbl(ListView1.Items(i).SubItems(6).Text)
            Next
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        Return k

    End Function

    Private Sub frmSales_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemove.Click
        Try

            If ListView1.Items.Count = 0 Then
                MsgBox("No items to remove", MsgBoxStyle.Critical, "Error")
            Else
                Dim itmCnt, i, t As Integer

                ListView1.FocusedItem.Remove()
                itmCnt = ListView1.Items.Count
                t = 1
                For i = 1 To itmCnt + 1

                    'Dim lst1 As New ListViewItem(i)
                    'ListView1.Items(i).SubItems(0).Text = t
                    t = t + 1

                Next
                txtSubTotal.Text = subtot()
            End If

            btnRemove.Enabled = False
            If ListView1.Items.Count = 0 Then
                txtSubTotal.Text = ""
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub txtCartons_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs)
        If (e.KeyChar < Chr(48) Or e.KeyChar > Chr(57)) And e.KeyChar <> Chr(8) Then

            e.Handled = True

        End If
    End Sub

    Private Sub txtTaxPer_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtTaxPer.KeyPress
        Dim keyChar = e.KeyChar

        If Char.IsControl(keyChar) Then
            'Allow all control characters.
        ElseIf Char.IsDigit(keyChar) OrElse keyChar = "."c Then
            Dim text = Me.txtTaxPer.Text
            Dim selectionStart = Me.txtTaxPer.SelectionStart
            Dim selectionLength = Me.txtTaxPer.SelectionLength

            text = text.Substring(0, selectionStart) & keyChar & text.Substring(selectionStart + selectionLength)

            If Integer.TryParse(text, New Integer) AndAlso text.Length > 16 Then
                'Reject an Integereger that is longer than 16 digits.
                e.Handled = True
            ElseIf Double.TryParse(text, New Double) AndAlso text.IndexOf("."c) < text.Length - 3 Then
                'Reject a real number with two many decimal places.
                e.Handled = False
            End If
        Else
            'Reject all other characters.
            e.Handled = True
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
      
        Try
            Cursor = Cursors.WaitCursor
            Timer1.Enabled = True
            Dim rpt As New rptInvoices() 'The report you created.
            Dim myConnection As OleDbConnection
            Dim MyCommand As New OleDbCommand()
            Dim myDA As New OleDbDataAdapter()
            Dim myDS As New DataSet 'The DataSet you created.
            myConnection = New OleDbConnection(cs)
            myConnection.Open()
            MyCommand.Connection = myConnection
            MyCommand.CommandText = "SELECT BillInfo.InvoiceNo,BillInfo.BillingDate, BillInfo.SupplierID, BillInfo.SubTotal,ProductSold.ProductCode, ProductSold.ProductName, ProductSold.Weight, ProductSold.Price, ProductSold.Packets, ProductSold.TotalAmount,Supplier.Name, Supplier.Address, Supplier.City, Supplier.Phone, Supplier.Email, Supplier.MobileNo, Supplier.Notes FROM ((BillInfo INNER JOIN ProductSold ON BillInfo.InvoiceNo = ProductSold.InvoiceNo) INNER JOIN Supplier ON BillInfo.SupplierID = Supplier.ID) where Billinfo.Invoiceno= '" & txtInvoiceNo.Text & "'"
            MyCommand.CommandType = CommandType.Text
            myDA.SelectCommand = MyCommand
            myDA.Fill(myDS, "BillInfo")
            myDA.Fill(myDS, "ProductSold")
            myDA.Fill(myDS, "Supplier")
            rpt.SetDataSource(myDS)
            frmReport.CrystalReportViewer1.ReportSource = rpt
            frmReport.Show()
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub delete_records()
        Try



            Dim RowsAffected As Integer = 0




            con = New OleDbConnection(cs)

            con.Open()


            Dim cq1 As String = "delete from productsold where invoiceno=@DELETE1;"


            cmd = New OleDbCommand(cq1)

            cmd.Connection = con

            cmd.Parameters.Add(New OleDbParameter("@DELETE1", System.Data.OleDB.OleDBType.VarChar, 20, "InvoiceNo"))


            cmd.Parameters("@DELETE1").Value = Trim(txtInvoiceNo.Text)
            cmd.ExecuteNonQuery()
            con.Close()
            con = New OleDbConnection(cs)

            con.Open()


            Dim cq As String = "delete from billinfo where invoiceno=@DELETE1;"


            cmd = New OleDbCommand(cq)

            cmd.Connection = con

            cmd.Parameters.Add(New OleDbParameter("@DELETE1", System.Data.OleDB.OleDBType.VarChar, 20, "InvoiceNo"))


            cmd.Parameters("@DELETE1").Value = Trim(txtInvoiceNo.Text)
            RowsAffected = cmd.ExecuteNonQuery()
            If RowsAffected > 0 Then

                MessageBox.Show("Successfully deleted", "Record", MessageBoxButtons.OK, MessageBoxIcon.Information)

                Reset()

            Else
                MessageBox.Show("No record found", "Sorry", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Reset()
                Reset()
            End If
            If con.State = ConnectionState.Open Then

                con.Close()
            End If

            con.Close()

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Delete.Click
        Try


            If MessageBox.Show("Do you really want to delete the record?", "Sales Record", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) = Windows.Forms.DialogResult.Yes Then
                delete_records()

            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Me.Reset()
        frmSalesRecord.fillName()
        frmSalesRecord.fillInvoiceNo()
        frmSalesRecord.DataGridView4.DataSource = Nothing
        frmSalesRecord.cmbInvoiceNo.Text = ""
        frmSalesRecord.GroupBox5.Visible = False
        frmSalesRecord.DataGridView3.DataSource = Nothing
        frmSalesRecord.cmbSupplierName.Text = ""
        frmSalesRecord.GroupBox4.Visible = False
        frmSalesRecord.DataGridView1.DataSource = Nothing
        frmSalesRecord.dtpInvoiceDateFrom.Text = Today
        frmSalesRecord.dtpInvoiceDateTo.Text = Today
        frmSalesRecord.GroupBox3.Visible = False
        frmSalesRecord.Show()
    End Sub




    Public Sub FillList()
        With ListView1
            .Clear()
            .Columns.Add("Column11", 0)
            .Columns.Add("Product Code", 90)
            .Columns.Add("Product Name", 250, HorizontalAlignment.Center)
            .Columns.Add("Weight/Qty", 90, HorizontalAlignment.Center)
            .Columns.Add("Unit Price", 80, HorizontalAlignment.Center)
            .Columns.Add("Cartons", 85, HorizontalAlignment.Center)
            .Columns.Add("Packets/Carton", 100, HorizontalAlignment.Center)
            .Columns.Add("Total packets", 90, HorizontalAlignment.Center)
            .Columns.Add("Total Amount", 92, HorizontalAlignment.Center)
            FillListView(ListView1, GetData(sSql))

        End With
    End Sub
    Public Function GetData(ByVal sSQL As String)

        Dim sqlCmd As OleDbCommand = New OleDbCommand(sSQL)
        Dim myData As OleDbDataReader

        con = New OleDbConnection(cs)

        Try
            con.Open()

            sqlCmd.Connection = con

            myData = sqlCmd.ExecuteReader

            Return myData
        Catch ex As Exception
            Return ex
        End Try
    End Function
    Sub tot()
        Dim dblTotal As Double = 0
        Dim dblTemp As Double

        For Each lvItem As ListViewItem In ListView1.Items
            If Double.TryParse(lvItem.SubItems(5).Text, dblTemp) Then
                dblTotal += dblTemp
            End If
        Next
        txtSubTotal.Text = dblTotal
    End Sub

    Sub Compute()
        Dim num1, num2 As Double
        num1 = CDbl((Val(txtSubTotal.Text) * Val(txtTaxPer.Text)) / 100)
        num1 = Math.Round(num1, 2)
        txtTaxAmt.Text = num1
        num2 = CDbl(Val(txtSubTotal.Text) - Val(txtTaxAmt.Text) - Val(txtPaidToSupplier.Text))
        num2 = Math.Round(num2, 2)
        txtProfit.Text = num2
      
    End Sub


    Private Sub ListView1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
        btnRemove.Enabled = True

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        frmSearchProduct.fillCategory()
        frmSearchProduct.fillProductName()
        frmSearchProduct.fillWeight()
        frmSearchProduct.txtProductName.Text = ""
        frmSearchProduct.cmbProductName.Text = ""
        frmSearchProduct.DataGridView1.DataSource = Nothing
        frmSearchProduct.cmbWeight.Text = ""
        frmSearchProduct.DataGridView2.DataSource = Nothing
        frmSearchProduct.DataGridView3.DataSource = Nothing
        frmSearchProduct.ComboBox1.Text = ""
        frmSearchProduct.ComboBox2.Text = ""
        frmSearchProduct.DataGridView4.DataSource = Nothing
        frmSearchProduct.cmbCategory.Text = ""
        frmSearchProduct.DataGridView5.DataSource = Nothing
        frmSearchProduct.Show()
    End Sub


    Private Sub txtTotalPayment_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPaidToSupplier.TextChanged
        Compute()
    End Sub


    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
        Try

            If Len(Trim(txtSupplierID.Text)) = 0 Then
                MessageBox.Show("Select Supplier id", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                txtSupplierID.Focus()
                Exit Sub
            End If
            If Len(Trim(txtSupplierName.Text)) = 0 Then
                MessageBox.Show("Select Supplier name", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Button1.Focus()
                Exit Sub
            End If

            If Len(Trim(txtTaxPer.Text)) = 0 Then
                MessageBox.Show("Please enter tax percentage", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                txtTaxPer.Focus()
                Exit Sub
            End If
            If Len(Trim(txtTaxAmt.Text)) = 0 Then
                MessageBox.Show("Please enter tax amount", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                txtTaxAmt.Focus()
                Exit Sub
            End If
            If Len(Trim(txtPaidToSupplier.Text)) = 0 Then
                MessageBox.Show("Please enter paid to supplier", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                txtPaidToSupplier.Focus()
                Exit Sub
            End If
            If ListView1.Items.Count = 0 Then
                MessageBox.Show("sorry no product added", "", MessageBoxButtons.OK, MessageBoxIcon.Warning)
                Exit Sub
            End If
            con = New OleDbConnection(cs)
            con.Open()

            Dim cb As String = "update billinfo set SupplierID='" & txtSupplierID.Text & "',TaxPerCentage= " & txtTaxPer.Text & ",TaxAmount= " & txtTaxAmt.Text & ",PaidToSupplier= " & txtPaidToSupplier.Text & ",Profit= " & txtProfit.Text & " where Invoiceno= '" & txtInvoiceNo.Text & "'"

            cmd = New OleDbCommand(cb)

            cmd.Connection = con

            cmd.ExecuteReader()

            If con.State = ConnectionState.Open Then
                con.Close()
            End If

            con.Close()
            MessageBox.Show("Successfully updated", "Record", MessageBoxButtons.OK, MessageBoxIcon.Information)

            btnUpdate.Enabled = False
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Cursor = Cursors.Default
        Timer1.Enabled = False
    End Sub

    Private Sub txtTaxPer_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtTaxPer.TextChanged
        Compute()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        frmSupplierRecords1.Show()
    End Sub

    Private Sub txtPaidToSupplier_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtPaidToSupplier.KeyPress
        Dim keyChar = e.KeyChar

        If Char.IsControl(keyChar) Then
            'Allow all control characters.
        ElseIf Char.IsDigit(keyChar) OrElse keyChar = "."c Then
            Dim text = Me.txtPaidToSupplier.Text
            Dim selectionStart = Me.txtPaidToSupplier.SelectionStart
            Dim selectionLength = Me.txtPaidToSupplier.SelectionLength

            text = text.Substring(0, selectionStart) & keyChar & text.Substring(selectionStart + selectionLength)

            If Integer.TryParse(text, New Integer) AndAlso text.Length > 16 Then
                'Reject an Integereger that is longer than 16 digits.
                e.Handled = True
            ElseIf Double.TryParse(text, New Double) AndAlso text.IndexOf("."c) < text.Length - 3 Then
                'Reject a real number with two many decimal places.
                e.Handled = False
            End If
        Else
            'Reject all other characters.
            e.Handled = True
        End If
    End Sub

    Private Sub txtPackets_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPackets.TextChanged
        Try
           
            Dim num As Double
            num = CDbl(Val(txtPackets.Text) * Val(txtPrice.Text))
            num = Math.Round(num, 2)
            txtTotalAmount.Text = num
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub txtPackets_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtPackets.KeyPress
        If (e.KeyChar < Chr(48) Or e.KeyChar > Chr(57)) And e.KeyChar <> Chr(8) Then

            e.Handled = True

        End If
    End Sub

    Private Sub txtPackets_Validating(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtPackets.Validating
        If Val(txtPackets.Text) > Val(txtAvailablePackets.Text) Then
            MessageBox.Show("sale packets are more than available packets", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtPackets.Text = ""
            txtPackets.Focus()
            Exit Sub
        End If
    End Sub
End Class