﻿Imports System.Data.OleDB
Imports Excel = Microsoft.Office.Interop.Excel
Public Class frmSales_CustomerRecord_Customer
    Dim rdr As OleDbDataReader = Nothing
    Dim dtable As DataTable
    Dim con As OleDbConnection = Nothing
    Dim adp As OleDbDataAdapter
    Dim ds As DataSet
    Dim cmd As OleDbCommand = Nothing
    Dim dt As New DataTable


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        DataGridView1.DataSource = Nothing
        dtpInvoiceDateFrom.Text = Today
        dtpInvoiceDateTo.Text = Today
        GroupBox3.Visible = False
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try

            GroupBox3.Visible = True
            con = New OleDbConnection(cs)

            con.Open()
            cmd = New OleDbCommand("SELECT (invoiceNo) as [Invoice No],(BillingDate) as [Invoice Date],(CustomerID) as [Customer ID],(Name) as [Customer Name],(SubTotal) as [Sub Total],(TaxPercentage) as [Tax %],(TaxAmount) as [Tax Amount],GrandTotal as [Grand Total],Cash,Change from Billinfo_Customer,Customer where Customer.ID=Billinfo_Customer.CustomerID and BillingDate between #" & dtpInvoiceDateFrom.Text & "# And #" & dtpInvoiceDateTo.Text & "# order by BillingDate", con)

            Dim myDA As OleDbDataAdapter = New OleDbDataAdapter(cmd)

            Dim myDataSet As DataSet = New DataSet()

            myDA.Fill(myDataSet, "Billinfo_Customer")

            DataGridView1.DataSource = myDataSet.Tables("Billinfo_Customer").DefaultView
            Dim sum As Double = 0
        
            For Each r As DataGridViewRow In Me.DataGridView1.Rows
                sum = sum + r.Cells(7).Value
            Next
            txtAmount.Text = sum
            con.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub




    Sub fillName()

        Try

            Dim CN As New OleDbConnection(cs)

            CN.Open()
            adp = New OleDbDataAdapter()
            adp.SelectCommand = New OleDbCommand("SELECT distinct (Name) FROM Billinfo_Customer,Customer where Customer.ID=Billinfo_Customer.CustomerID", CN)
            ds = New DataSet("ds")

            adp.Fill(ds)
            dtable = ds.Tables(0)
            cmbCustomerName.Items.Clear()

            For Each drow As DataRow In dtable.Rows
                cmbCustomerName.Items.Add(drow(0).ToString())
                'DocName.SelectedIndex = -1
            Next
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Sub fillInvoiceNo()

        Try

            Dim CN As New OleDbConnection(cs)

            CN.Open()
            adp = New OleDbDataAdapter()
            adp.SelectCommand = New OleDbCommand("SELECT distinct (invoiceno) FROM Billinfo_Customer", CN)
            ds = New DataSet("ds")

            adp.Fill(ds)
            dtable = ds.Tables(0)
            cmbInvoiceNo.Items.Clear()

            For Each drow As DataRow In dtable.Rows
                cmbInvoiceNo.Items.Add(drow(0).ToString())
                'DocName.SelectedIndex = -1
            Next
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub


    Private Sub frmSales_CustomerRecord_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        fillInvoiceNo()
        fillName()
    End Sub



    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If DataGridView1.RowCount = Nothing Then
            MessageBox.Show("Sorry nothing to export into excel sheet.." & vbCrLf & "Please retrieve data in datagridview", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        Dim rowsTotal, colsTotal As Short
        Dim I, j, iC As Short
        System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor
        Dim xlApp As New Excel.Application

        Try
            Dim excelBook As Excel.Workbook = xlApp.Workbooks.Add
            Dim excelWorksheet As Excel.Worksheet = CType(excelBook.Worksheets(1), Excel.Worksheet)
            xlApp.Visible = True

            rowsTotal = DataGridView1.RowCount - 1
            colsTotal = DataGridView1.Columns.Count - 1
            With excelWorksheet
                .Cells.Select()
                .Cells.Delete()
                For iC = 0 To colsTotal
                    .Cells(1, iC + 1).Value = DataGridView1.Columns(iC).HeaderText
                Next
                For I = 0 To rowsTotal - 1
                    For j = 0 To colsTotal
                        .Cells(I + 2, j + 1).value = DataGridView1.Rows(I).Cells(j).Value
                    Next j
                Next I
                .Rows("1:1").Font.FontStyle = "Bold"
                .Rows("1:1").Font.Size = 12

                .Cells.Columns.AutoFit()
                .Cells.Select()
                .Cells.EntireColumn.AutoFit()
                .Cells(1, 1).Select()
            End With
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            'RELEASE ALLOACTED RESOURCES
            System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default
            xlApp = Nothing
        End Try
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        If DataGridView3.RowCount = Nothing Then
            MessageBox.Show("Sorry nothing to export into excel sheet.." & vbCrLf & "Please retrieve data in datagridview", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        Dim rowsTotal, colsTotal As Short
        Dim I, j, iC As Short
        System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor
        Dim xlApp As New Excel.Application

        Try
            Dim excelBook As Excel.Workbook = xlApp.Workbooks.Add
            Dim excelWorksheet As Excel.Worksheet = CType(excelBook.Worksheets(1), Excel.Worksheet)
            xlApp.Visible = True

            rowsTotal = DataGridView3.RowCount - 1
            colsTotal = DataGridView3.Columns.Count - 1
            With excelWorksheet
                .Cells.Select()
                .Cells.Delete()
                For iC = 0 To colsTotal
                    .Cells(1, iC + 1).Value = DataGridView3.Columns(iC).HeaderText
                Next
                For I = 0 To rowsTotal - 1
                    For j = 0 To colsTotal
                        .Cells(I + 2, j + 1).value = DataGridView3.Rows(I).Cells(j).Value
                    Next j
                Next I
                .Rows("1:1").Font.FontStyle = "Bold"
                .Rows("1:1").Font.Size = 12

                .Cells.Columns.AutoFit()
                .Cells.Select()
                .Cells.EntireColumn.AutoFit()
                .Cells(1, 1).Select()
            End With
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            'RELEASE ALLOACTED RESOURCES
            System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default
            xlApp = Nothing
        End Try
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        If DataGridView4.RowCount = Nothing Then
            MessageBox.Show("Sorry nothing to export into excel sheet.." & vbCrLf & "Please retrieve data in datagridview", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        Dim rowsTotal, colsTotal As Short
        Dim I, j, iC As Short
        System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor
        Dim xlApp As New Excel.Application

        Try
            Dim excelBook As Excel.Workbook = xlApp.Workbooks.Add
            Dim excelWorksheet As Excel.Worksheet = CType(excelBook.Worksheets(1), Excel.Worksheet)
            xlApp.Visible = True

            rowsTotal = DataGridView4.RowCount - 1
            colsTotal = DataGridView4.Columns.Count - 1
            With excelWorksheet
                .Cells.Select()
                .Cells.Delete()
                For iC = 0 To colsTotal
                    .Cells(1, iC + 1).Value = DataGridView4.Columns(iC).HeaderText
                Next
                For I = 0 To rowsTotal - 1
                    For j = 0 To colsTotal
                        .Cells(I + 2, j + 1).value = DataGridView4.Rows(I).Cells(j).Value
                    Next j
                Next I
                .Rows("1:1").Font.FontStyle = "Bold"
                .Rows("1:1").Font.Size = 12

                .Cells.Columns.AutoFit()
                .Cells.Select()
                .Cells.EntireColumn.AutoFit()
                .Cells(1, 1).Select()
            End With
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            'RELEASE ALLOACTED RESOURCES
            System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default
            xlApp = Nothing
        End Try
    End Sub



    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        DataGridView3.DataSource = Nothing
        cmbCustomerName.Text = ""
        GroupBox4.Visible = False
    End Sub



    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        DataGridView4.DataSource = Nothing
        cmbInvoiceNo.Text = ""
        GroupBox5.Visible = False
    End Sub

    Private Sub TabControl1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl1.Click
        DataGridView4.DataSource = Nothing
        cmbInvoiceNo.Text = ""
        GroupBox5.Visible = False
        DataGridView3.DataSource = Nothing
        cmbCustomerName.Text = ""
        GroupBox4.Visible = False
        DataGridView1.DataSource = Nothing
        dtpInvoiceDateFrom.Text = Today
        dtpInvoiceDateTo.Text = Today
        GroupBox3.Visible = False
    End Sub

    Private Sub DataGridView1_RowHeaderMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView1.RowHeaderMouseClick
        Try
            Dim dr As DataGridViewRow = DataGridView1.SelectedRows(0)
            Me.Hide()
            frmSales_Customer.Show()
            ' or simply use column name instead of index
            'dr.Cells["id"].Value.ToString();
            frmSales_Customer.txtInvoiceNo.Text = dr.Cells(0).Value.ToString()
            frmSales_Customer.dtpTransactionDate.Text = dr.Cells(1).Value.ToString()
            frmSales_Customer.txtCustomerID.Text = dr.Cells(2).Value.ToString()
            frmSales_Customer.txtCustomerName.Text = dr.Cells(3).Value.ToString()
            frmSales_Customer.txtSubTotal.Text = dr.Cells(4).Value.ToString()
            frmSales_Customer.txtTaxPer.Text = dr.Cells(5).Value.ToString()
            frmSales_Customer.txtTaxAmt.Text = dr.Cells(6).Value.ToString()
            frmSales_Customer.txtTotal.Text = dr.Cells(7).Value.ToString()
            frmSales_Customer.txtCash.Text = dr.Cells(8).Value.ToString()
            frmSales_Customer.txtChange.Text = dr.Cells(9).Value.ToString()
            con = New OleDbConnection(cs)
            con.Open()
            cmd = New OleDbCommand("SELECT ProductCode,ProductName,Weight,Price,Packets,TotalAmount from Billinfo_Customer,ProductSold_Customer where Billinfo_Customer.InvoiceNo=ProductSold_Customer.InvoiceNo and Billinfo_Customer.InvoiceNo='" & dr.Cells(0).Value & "'", con)
            rdr = cmd.ExecuteReader()
            While rdr.Read()

                Dim lst As New ListViewItem()
                lst.SubItems.Add(rdr(0).ToString().Trim())
                lst.SubItems.Add(rdr.GetString(1))
                lst.SubItems.Add(rdr(2).ToString())
                lst.SubItems.Add(rdr.GetDouble(3))
                lst.SubItems.Add(rdr.GetInt32(4))
                lst.SubItems.Add(rdr.GetDouble(5))
                frmSales_Customer.ListView1.Items.Add(lst)
            End While
            frmSales_Customer.btnUpdate.Enabled = True
            frmSales_Customer.Delete.Enabled = True
            frmSales_Customer.btnPrint.Enabled = True
            frmSales_Customer.Save.Enabled = False
            frmSales_Customer.Button7.Enabled = False
            frmSales_Customer.ListView1.Enabled = False
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub


    Private Sub DataGridView3_RowHeaderMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView3.RowHeaderMouseClick
        Try
            Dim dr As DataGridViewRow = DataGridView3.SelectedRows(0)
            Me.Hide()
            frmSales_Customer.Show()
            ' or simply use column name instead of index
            'dr.Cells["id"].Value.ToString();
            frmSales_Customer.txtInvoiceNo.Text = dr.Cells(0).Value.ToString()
            frmSales_Customer.dtpTransactionDate.Text = dr.Cells(1).Value.ToString()
            frmSales_Customer.txtCustomerID.Text = dr.Cells(2).Value.ToString()
            frmSales_Customer.txtCustomerName.Text = dr.Cells(3).Value.ToString()
            frmSales_Customer.txtSubTotal.Text = dr.Cells(4).Value.ToString()
            frmSales_Customer.txtTaxPer.Text = dr.Cells(5).Value.ToString()
            frmSales_Customer.txtTaxAmt.Text = dr.Cells(6).Value.ToString()
            frmSales_Customer.txtTotal.Text = dr.Cells(7).Value.ToString()
            frmSales_Customer.txtCash.Text = dr.Cells(8).Value.ToString()
            frmSales_Customer.txtChange.Text = dr.Cells(9).Value.ToString()
            con = New OleDbConnection(cs)
            con.Open()
            cmd = New OleDbCommand("SELECT ProductCode,ProductName,Weight,Price,Packets,TotalAmount from Billinfo_Customer,ProductSold_Customer where Billinfo_Customer.InvoiceNo=ProductSold_Customer.InvoiceNo and Billinfo_Customer.InvoiceNo='" & dr.Cells(0).Value & "'", con)
            rdr = cmd.ExecuteReader()
            While rdr.Read()

                Dim lst As New ListViewItem()
                lst.SubItems.Add(rdr(0).ToString().Trim())
                lst.SubItems.Add(rdr.GetString(1))
                lst.SubItems.Add(rdr(2).ToString())
                lst.SubItems.Add(rdr.GetDouble(3))
                lst.SubItems.Add(rdr.GetInt32(4))
                lst.SubItems.Add(rdr.GetDouble(5))
                frmSales_Customer.ListView1.Items.Add(lst)
            End While
            frmSales_Customer.btnUpdate.Enabled = True
            frmSales_Customer.Delete.Enabled = True
            frmSales_Customer.btnPrint.Enabled = True
            frmSales_Customer.Save.Enabled = False
            frmSales_Customer.Button7.Enabled = False
            frmSales_Customer.ListView1.Enabled = False
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub DataGridView4_RowHeaderMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView4.RowHeaderMouseClick
        Try
            Dim dr As DataGridViewRow = DataGridView4.SelectedRows(0)
            Me.Hide()
            frmSales_Customer.Show()
            ' or simply use column name instead of index
            'dr.Cells["id"].Value.ToString();
            frmSales_Customer.txtInvoiceNo.Text = dr.Cells(0).Value.ToString()
            frmSales_Customer.dtpTransactionDate.Text = dr.Cells(1).Value.ToString()
            frmSales_Customer.txtCustomerID.Text = dr.Cells(2).Value.ToString()
            frmSales_Customer.txtCustomerName.Text = dr.Cells(3).Value.ToString()
            frmSales_Customer.txtSubTotal.Text = dr.Cells(4).Value.ToString()
            frmSales_Customer.txtTaxPer.Text = dr.Cells(5).Value.ToString()
            frmSales_Customer.txtTaxAmt.Text = dr.Cells(6).Value.ToString()
            frmSales_Customer.txtTotal.Text = dr.Cells(7).Value.ToString()
            frmSales_Customer.txtCash.Text = dr.Cells(8).Value.ToString()
            frmSales_Customer.txtChange.Text = dr.Cells(9).Value.ToString()
            con = New OleDbConnection(cs)
            con.Open()
            cmd = New OleDbCommand("SELECT ProductCode,ProductName,Weight,Price,Packets,TotalAmount from Billinfo_Customer,ProductSold_Customer where Billinfo_Customer.InvoiceNo=ProductSold_Customer.InvoiceNo and Billinfo_Customer.InvoiceNo='" & dr.Cells(0).Value & "'", con)
            rdr = cmd.ExecuteReader()
            While rdr.Read()

                Dim lst As New ListViewItem()
                lst.SubItems.Add(rdr(0).ToString().Trim())
                lst.SubItems.Add(rdr.GetString(1))
                lst.SubItems.Add(rdr(2).ToString())
                lst.SubItems.Add(rdr.GetDouble(3))
                lst.SubItems.Add(rdr.GetInt32(4))
                lst.SubItems.Add(rdr.GetDouble(5))
                frmSales_Customer.ListView1.Items.Add(lst)
            End While
            frmSales_Customer.btnUpdate.Enabled = True
            frmSales_Customer.Delete.Enabled = True
            frmSales_Customer.btnPrint.Enabled = True
            frmSales_Customer.Save.Enabled = False
            frmSales_Customer.Button7.Enabled = False
            frmSales_Customer.ListView1.Enabled = False
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub


    Private Sub cmbInvoiceNo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbInvoiceNo.SelectedIndexChanged
        Try

            GroupBox5.Visible = True
            con = New OleDbConnection(cs)

            con.Open()
            cmd = New OleDbCommand(" SELECT (invoiceNo) as [Invoice No],(BillingDate) as [Invoice Date],(CustomerID) as [Customer ID],(Name) as [Customer Name],(SubTotal) as [Sub Total],(TaxPercentage) as [Tax %],(TaxAmount) as [Tax Amount],GrandTotal as [Grand Total],Cash,Change from Billinfo_Customer,Customer where Customer.ID=Billinfo_Customer.CustomerID and invoiceno = '" & cmbInvoiceNo.Text & "' order by BillingDate", con)


            Dim myDA As OleDbDataAdapter = New OleDbDataAdapter(cmd)

            Dim myDataSet As DataSet = New DataSet()

            myDA.Fill(myDataSet, "Billinfo_Customer")

            DataGridView4.DataSource = myDataSet.Tables("Billinfo_Customer").DefaultView
            Dim sum As Double = 0
           
            For Each r As DataGridViewRow In Me.DataGridView4.Rows
                sum = sum + r.Cells(7).Value
            Next
            txtAmount2.Text = sum
            con.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub GroupBox1_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GroupBox1.Enter

    End Sub

    Private Sub DataGridView1_RowPostPaint(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewRowPostPaintEventArgs) Handles DataGridView1.RowPostPaint
        Dim strRowNumber As String = (e.RowIndex + 1).ToString()
        Dim size As SizeF = e.Graphics.MeasureString(strRowNumber, Me.Font)
        If DataGridView1.RowHeadersWidth < Convert.ToInt32((size.Width + 20)) Then
            DataGridView1.RowHeadersWidth = Convert.ToInt32((size.Width + 20))
        End If
        Dim b As Brush = SystemBrushes.ControlText
        e.Graphics.DrawString(strRowNumber, Me.Font, b, e.RowBounds.Location.X + 15, e.RowBounds.Location.Y + ((e.RowBounds.Height - size.Height) / 2))

    End Sub

    Private Sub DataGridView3_RowPostPaint(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewRowPostPaintEventArgs) Handles DataGridView3.RowPostPaint
        Dim strRowNumber As String = (e.RowIndex + 1).ToString()
        Dim size As SizeF = e.Graphics.MeasureString(strRowNumber, Me.Font)
        If DataGridView3.RowHeadersWidth < Convert.ToInt32((size.Width + 20)) Then
            DataGridView3.RowHeadersWidth = Convert.ToInt32((size.Width + 20))
        End If
        Dim b As Brush = SystemBrushes.ControlText
        e.Graphics.DrawString(strRowNumber, Me.Font, b, e.RowBounds.Location.X + 15, e.RowBounds.Location.Y + ((e.RowBounds.Height - size.Height) / 2))

    End Sub

    Private Sub DataGridView4_RowPostPaint(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewRowPostPaintEventArgs) Handles DataGridView4.RowPostPaint
        Dim strRowNumber As String = (e.RowIndex + 1).ToString()
        Dim size As SizeF = e.Graphics.MeasureString(strRowNumber, Me.Font)
        If DataGridView4.RowHeadersWidth < Convert.ToInt32((size.Width + 20)) Then
            DataGridView4.RowHeadersWidth = Convert.ToInt32((size.Width + 20))
        End If
        Dim b As Brush = SystemBrushes.ControlText
        e.Graphics.DrawString(strRowNumber, Me.Font, b, e.RowBounds.Location.X + 15, e.RowBounds.Location.Y + ((e.RowBounds.Height - size.Height) / 2))

    End Sub

    Private Sub cmbCustomerName_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbCustomerName.SelectedIndexChanged
        Try

            GroupBox4.Visible = True
            con = New OleDbConnection(cs)

            con.Open()
            cmd = New OleDbCommand("SELECT (invoiceNo) as [Invoice No],(BillingDate) as [Invoice Date],(CustomerID) as [Customer ID],(Name) as [Customer Name],(SubTotal) as [Sub Total],(TaxPercentage) as [Tax %],(TaxAmount) as [Tax Amount],GrandTotal as [Grand Total],Cash,Change from Billinfo_Customer,Customer where Customer.ID=Billinfo_Customer.CustomerID and Name= '" & cmbCustomerName.Text & "' order by BillingDate", con)


            Dim myDA As OleDbDataAdapter = New OleDbDataAdapter(cmd)

            Dim myDataSet As DataSet = New DataSet()

            myDA.Fill(myDataSet, "Billinfo_Customer")

            DataGridView3.DataSource = myDataSet.Tables("Billinfo_Customer").DefaultView
            Dim sum As Double = 0
            For Each r As DataGridViewRow In Me.DataGridView3.Rows
                sum = sum + r.Cells(7).Value
            Next
            txtAmount1.Text = sum
            con.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
End Class